#include "misc.h"
#include "naw.h"
#include "naw_log.h"

/***************************************************************************
  naw_test_module_accept

  takes the place of both 'accept' and 'reject' actions.  Only returns YES,
  so 'deny' actions will result in rejection, and 'accept' actions will
  result in access.
 ***************************************************************************/

static int naw_test_module_accept (handle, data)
    struct naw_handle *handle;
    struct naw_data *data;
{
    char *v;
    unsigned int vlen;
    if (!naw_data_get(data, "false", &v, &vlen))
        NAW_LOG (NAW_DEBUG,LXM_q("false: "),LXM_mb(v,vlen));

    NAW_LOG (NAW_DEBUG2,LXM_q("false: rejecting connection"));
    return NAW_NO;
}

struct naw_modfuncset naw_set = {
    naw_test_module_accept,  /* accept  */
    naw_test_module_accept,  /* connect */
    0,                       /* init    */
    0,                       /* fini    */
};

