#include <string.h>
#include <ctype.h>
#include <lx_string.h>
#include "misc.h"
#include "cfg_stuff.h"

static void cfg_set_process_run ();
wordset *cfg_check_word();


static inline void cfg_set_order (os, args)
    orderset *os;
    struct cfg_set_args *args;
{
    unsigned int instance;

    for (; os->ws; os++) {
        instance = 0;
        while (instance++ < os->instance_max) {
            cfg_set_process_run (os->ws, args);
        }

        if (instance <= os->instance_min)
            die_cfg_syntax(linenum, args->txt->s, args->txt->len);
    }
}

static void cfg_set_process_run (ws, args)
    wordset *ws;
    struct cfg_set_args *args;
{
    int wordlen;

    struct cfg_set_args nextargs = *args;
    memset (&args->flags, 0, sizeof(args->flags));


    for (;;) {
        ws = cfg_check_word (args->gd, args->txt, ws, &wordlen);

        if (!ws) {
            if (!args->flags.optional)
                die_cfg_syntax(linenum, args->txt->s, args->txt->len);
            continue;
        }

        cfg_line_advance(args->txt, wordlen + 1);

        if (ws->f) ws->f(args);

        if (ws->flags & OPTIONAL)
            nextargs.flags.optional = 1;

        if (!ws->nextset) return;

        if (ws->flags & ORDERSET)
            cfg_set_order (ws->nextset, &nextargs);
    }
}

void cfg_set_process (gd, cfgtxt, link)
    lx_gd *gd;
    lx_s *cfgtxt;
    struct cfglink *link;
{
    struct cfg_set_args args;

    memset (&args, 0, sizeof(args));

    args.gd = gd;
    args.txt = cfgtxt;
    args.link = link;

    cfg_set_process_run(&ws_main[0], &args);

    if (cfgtxt->len) die_cfg_syntax(linenum, cfgtxt->s, cfgtxt->len);
}
