#include "lxmisc.h"
#include "misc.h"

void send_proto (gd, proto, okay)
	lx_gd *gd;
	unsigned char proto, *okay;
{
	*okay = 0;

	if (lx_gdputc (gd, proto)
	 || lx_gdputc (gd, 0)
	 || lx_gdflush(gd)) return;

	(*okay)++;
}

void recv_proto (gd, proto, okay)
	lx_gd *gd;
	unsigned char *proto, *okay;
{
	char match;
	lx_s ns = {0};

	*okay = 0;

	if (lx_getseg (&ns, gd, "\0", &match, 2)) {
		log_debug (1, "recv_proto(): couldn't get 0-delimited segment", 0,0,0,0);
		return;
	}

	if (match & MATCH_TOOLONG) {
		log_debug (1, "recv_proto(): protocol is more than one character", 0,0,0,0);
		goto RETURN;
	}

	if (!(match & MATCH_OK)) {
		log_debug (1, "recv_proto(): binary zero expected", 0,0,0,0);
		goto RETURN;
	}

	if (ns.len != 2) {
		char len[2] = { ns.len + '0', 0 };
		log_debug (1, "recv_proto(): protocol length not 1: ", len,0,0,0);
		goto RETURN;
	}

	*proto = *(ns.s);
	(*okay)++;

RETURN:
	lx_free (&ns);
}
